<?php
 namespace MongoDB\Operation;
 use ArrayIterator;
 use MongoDB\Driver\Command;
 use MongoDB\Driver\Exception\RuntimeException as DriverRuntimeException;
 use MongoDB\Driver\ReadConcern;
 use MongoDB\Driver\ReadPreference;
 use MongoDB\Driver\Server;
 use MongoDB\Driver\Session;
 use MongoDB\Driver\WriteConcern;
 use MongoDB\Exception\InvalidArgumentException;
 use MongoDB\Exception\UnexpectedValueException;
 use MongoDB\Exception\UnsupportedException;
 use stdClass;
 use Traversable;
 use function current;
 use function is_array;
 use function is_bool;
 use function is_integer;
 use function is_object;
 use function is_string;
 use function MongoDB\create_field_path_type_map;
 use function MongoDB\is_last_pipeline_operator_write;
 use function MongoDB\server_supports_feature;
 use function sprintf;
 class Aggregate implements Executable {
 private static $wireVersionForCollation = 5;
 private static $wireVersionForDocumentLevelValidation = 4;
 private static $wireVersionForReadConcern = 4;
 private static $wireVersionForWriteConcern = 5;
 private $databaseName;
 private $collectionName;
 private $pipeline;
 private $options;
 public function __construct($databaseName, $collectionName, array $pipeline, array $options = []) {
 $expectedIndex = 0;
 foreach ($pipeline as $i => $operation) {
 if ($i !== $expectedIndex) {
 throw new InvalidArgumentException(sprintf('$pipeline is not a list (unexpected index: "%s")', $i));
 }
 if (! is_array($operation) && ! is_object($operation)) {
 throw InvalidArgumentException::invalidType(sprintf('$pipeline[%d]', $i), $operation, 'array or object');
 }
 $expectedIndex += 1;
 }
 $options += [ 'allowDiskUse' => false, 'useCursor' => true, ];
 if (! is_bool($options['allowDiskUse'])) {
 throw InvalidArgumentException::invalidType('"allowDiskUse" option', $options['allowDiskUse'], 'boolean');
 }
 if (isset($options['batchSize']) && ! is_integer($options['batchSize'])) {
 throw InvalidArgumentException::invalidType('"batchSize" option', $options['batchSize'], 'integer');
 }
 if (isset($options['bypassDocumentValidation']) && ! is_bool($options['bypassDocumentValidation'])) {
 throw InvalidArgumentException::invalidType('"bypassDocumentValidation" option', $options['bypassDocumentValidation'], 'boolean');
 }
 if (isset($options['collation']) && ! is_array($options['collation']) && ! is_object($options['collation'])) {
 throw InvalidArgumentException::invalidType('"collation" option', $options['collation'], 'array or object');
 }
 if (isset($options['comment']) && ! is_string($options['comment'])) {
 throw InvalidArgumentException::invalidType('"comment" option', $options['comment'], 'string');
 }
 if (isset($options['explain']) && ! is_bool($options['explain'])) {
 throw InvalidArgumentException::invalidType('"explain" option', $options['explain'], 'boolean');
 }
 if (isset($options['hint']) && ! is_string($options['hint']) && ! is_array($options['hint']) && ! is_object($options['hint'])) {
 throw InvalidArgumentException::invalidType('"hint" option', $options['hint'], 'string or array or object');
 }
 if (isset($options['maxAwaitTimeMS']) && ! is_integer($options['maxAwaitTimeMS'])) {
 throw InvalidArgumentException::invalidType('"maxAwaitTimeMS" option', $options['maxAwaitTimeMS'], 'integer');
 }
 if (isset($options['maxTimeMS']) && ! is_integer($options['maxTimeMS'])) {
 throw InvalidArgumentException::invalidType('"maxTimeMS" option', $options['maxTimeMS'], 'integer');
 }
 if (isset($options['readConcern']) && ! $options['readConcern'] instanceof ReadConcern) {
 throw InvalidArgumentException::invalidType('"readConcern" option', $options['readConcern'], ReadConcern::class);
 }
 if (isset($options['readPreference']) && ! $options['readPreference'] instanceof ReadPreference) {
 throw InvalidArgumentException::invalidType('"readPreference" option', $options['readPreference'], ReadPreference::class);
 }
 if (isset($options['session']) && ! $options['session'] instanceof Session) {
 throw InvalidArgumentException::invalidType('"session" option', $options['session'], Session::class);
 }
 if (isset($options['typeMap']) && ! is_array($options['typeMap'])) {
 throw InvalidArgumentException::invalidType('"typeMap" option', $options['typeMap'], 'array');
 }
 if (! is_bool($options['useCursor'])) {
 throw InvalidArgumentException::invalidType('"useCursor" option', $options['useCursor'], 'boolean');
 }
 if (isset($options['writeConcern']) && ! $options['writeConcern'] instanceof WriteConcern) {
 throw InvalidArgumentException::invalidType('"writeConcern" option', $options['writeConcern'], WriteConcern::class);
 }
 if (isset($options['batchSize']) && ! $options['useCursor']) {
 throw new InvalidArgumentException('"batchSize" option should not be used if "useCursor" is false');
 }
 if (isset($options['readConcern']) && $options['readConcern']->isDefault()) {
 unset($options['readConcern']);
 }
 if (isset($options['writeConcern']) && $options['writeConcern']->isDefault()) {
 unset($options['writeConcern']);
 }
 if (! empty($options['explain'])) {
 $options['useCursor'] = false;
 }
 $this->databaseName = (string) $databaseName;
 $this->collectionName = isset($collectionName) ? (string) $collectionName : null;
 $this->pipeline = $pipeline;
 $this->options = $options;
 }
 public function execute(Server $server) {
 if (isset($this->options['collation']) && ! server_supports_feature($server, self::$wireVersionForCollation)) {
 throw UnsupportedException::collationNotSupported();
 }
 if (isset($this->options['readConcern']) && ! server_supports_feature($server, self::$wireVersionForReadConcern)) {
 throw UnsupportedException::readConcernNotSupported();
 }
 if (isset($this->options['writeConcern']) && ! server_supports_feature($server, self::$wireVersionForWriteConcern)) {
 throw UnsupportedException::writeConcernNotSupported();
 }
 $inTransaction = isset($this->options['session']) && $this->options['session']->isInTransaction();
 if ($inTransaction) {
 if (isset($this->options['readConcern'])) {
 throw UnsupportedException::readConcernNotSupportedInTransaction();
 }
 if (isset($this->options['writeConcern'])) {
 throw UnsupportedException::writeConcernNotSupportedInTransaction();
 }
 }
 $hasExplain = ! empty($this->options['explain']);
 $hasWriteStage = is_last_pipeline_operator_write($this->pipeline);
 $command = $this->createCommand($server, $hasWriteStage);
 $options = $this->createOptions($hasWriteStage, $hasExplain);
 $cursor = $hasWriteStage && ! $hasExplain ? $server->executeReadWriteCommand($this->databaseName, $command, $options) : $server->executeReadCommand($this->databaseName, $command, $options);
 if ($this->options['useCursor'] || $hasExplain) {
 if (isset($this->options['typeMap'])) {
 $cursor->setTypeMap($this->options['typeMap']);
 }
 return $cursor;
 }
 if (isset($this->options['typeMap'])) {
 $cursor->setTypeMap(create_field_path_type_map($this->options['typeMap'], 'result.$'));
 }
 $result = current($cursor->toArray());
 if (! isset($result->result) || ! is_array($result->result)) {
 throw new UnexpectedValueException('aggregate command did not return a "result" array');
 }
 return new ArrayIterator($result->result);
 }
 private function createCommand(Server $server, $hasWriteStage) {
 $cmd = [ 'aggregate' => isset($this->collectionName) ? $this->collectionName : 1, 'pipeline' => $this->pipeline, ];
 $cmdOptions = [];
 $cmd['allowDiskUse'] = $this->options['allowDiskUse'];
 if (! empty($this->options['bypassDocumentValidation']) && server_supports_feature($server, self::$wireVersionForDocumentLevelValidation) ) {
 $cmd['bypassDocumentValidation'] = $this->options['bypassDocumentValidation'];
 }
 foreach (['comment', 'explain', 'maxTimeMS'] as $option) {
 if (isset($this->options[$option])) {
 $cmd[$option] = $this->options[$option];
 }
 }
 if (isset($this->options['collation'])) {
 $cmd['collation'] = (object) $this->options['collation'];
 }
 if (isset($this->options['hint'])) {
 $cmd['hint'] = is_array($this->options['hint']) ? (object) $this->options['hint'] : $this->options['hint'];
 }
 if (isset($this->options['maxAwaitTimeMS'])) {
 $cmdOptions['maxAwaitTimeMS'] = $this->options['maxAwaitTimeMS'];
 }
 if ($this->options['useCursor']) {
 $cmd['cursor'] = isset($this->options["batchSize"]) && ! $hasWriteStage ? ['batchSize' => $this->options["batchSize"]] : new stdClass();
 }
 return new Command($cmd, $cmdOptions);
 }
 private function createOptions($hasWriteStage, $hasExplain) {
 $options = [];
 if (isset($this->options['readConcern'])) {
 $options['readConcern'] = $this->options['readConcern'];
 }
 if (! $hasWriteStage && isset($this->options['readPreference'])) {
 $options['readPreference'] = $this->options['readPreference'];
 }
 if (isset($this->options['session'])) {
 $options['session'] = $this->options['session'];
 }
 if ($hasWriteStage && ! $hasExplain && isset($this->options['writeConcern'])) {
 $options['writeConcern'] = $this->options['writeConcern'];
 }
 return $options;
 }
 }
 